local rns

function selected_slots()

  local range, added_patterns = { }, { }
  local sequencer = rns.sequencer

  for track_i = 1, #rns.tracks do
    for seq, pattern_i in ipairs(sequencer.pattern_sequence) do
      if sequencer:track_sequence_slot_is_selected(track_i, seq) then
        if not added_patterns[pattern_i] then
          added_patterns[pattern_i] = track_i
          range[#range+1] = {
            pattern = pattern_i,
            track = track_i,
            sequence = seq
          }
        end
      end
    end
    added_patterns = { }
  end

  if #range == 1 then
    range = { }
    for track_i = 1, #rns.tracks do
      for seq, pattern_i in ipairs(sequencer.pattern_sequence) do
        if not added_patterns[pattern_i] then
          added_patterns[pattern_i] = track_i
          range[#range+1] = {
            pattern = pattern_i,
            track = track_i,
            sequence = seq
          }
        end
      end
      added_patterns = { }
    end
  end

  return range
end


function hash_patterntrack(pattern_i, track_i, patterntrack)

  local str = ""

  for line_index, line in ipairs(patterntrack.lines) do
    if not line.is_empty then
      str = str .. line_index .. tostring(line)
    end
  end

  return str .. track_i
end


function alias_identical()

  rns = renoise.song()
  local pt_hash
  local t_hash = { }
  local patterntrack

  renoise.app():show_status("Aliasing Identical Slots...")

  for i, slot in ipairs(selected_slots()) do
    patterntrack = rns:pattern(slot.pattern):track(slot.track)
    if (not patterntrack.is_alias) and (not patterntrack.is_empty) then
      pt_hash = hash_patterntrack(slot.pattern, slot.track, patterntrack)
      if not t_hash[pt_hash] then
        t_hash[pt_hash] = {
          pattern = slot.pattern,
          track = slot.track
        }
      elseif t_hash[pt_hash].track == slot.track then
        patterntrack.alias_pattern_index = t_hash[pt_hash].pattern
      end
    end
  end

  renoise.app():show_status("Identical Slots Aliased")
 
end


renoise.tool():add_menu_entry {
  name = "Pattern Matrix:Alias Identical Slots",
  invoke = alias_identical
}
